diff --git a/kimap/session.cpp b/kimap/session.cpp
index 031508b..2b23adc 100644
--- a/kimap/session.cpp
+++ b/kimap/session.cpp
@@ -27,7 +27,8 @@
 #include <QtCore/QDebug>
 #include <QtCore/QTimer>
 
-#include <klocale.h>
+#include <KDebug>
+#include <KDE/KLocalizedString>
 
 #include "job.h"
 #include "loginjob.h"
@@ -36,14 +37,14 @@
 #include "sessionthread_p.h"
 #include "rfccodecs.h"
 
-Q_DECLARE_METATYPE(KTcpSocket::SslVersion)
-Q_DECLARE_METATYPE(QSslSocket::SslMode)
+Q_DECLARE_METATYPE( KTcpSocket::SslVersion )
+Q_DECLARE_METATYPE( QSslSocket::SslMode )
 static const int _kimap_sslVersionId = qRegisterMetaType<KTcpSocket::SslVersion>();
 
 using namespace KIMAP;
 
 Session::Session( const QString &hostName, quint16 port, QObject *parent)
-  : QObject(parent), d(new SessionPrivate(this))
+  : QObject( parent ), d( new SessionPrivate( this ) )
 {
   if ( !qgetenv( "KIMAP_LOGFILE" ).isEmpty() ) {
     d->logger = new SessionLogger;
@@ -53,13 +54,23 @@ Session::Session( const QString &hostName, quint16 port, QObject *parent)
   d->state = Disconnected;
   d->jobRunning = false;
 
-  d->thread = new SessionThread(hostName, port, this);
-  connect(d->thread, SIGNAL(encryptionNegotiationResult(bool,KTcpSocket::SslVersion)),
-          d, SLOT(onEncryptionNegotiationResult(bool,KTcpSocket::SslVersion)));
-  connect(d->thread, SIGNAL(sslError(KSslErrorUiData)), this, SLOT(handleSslError(KSslErrorUiData)));
+  d->thread = new SessionThread( hostName, port );
+  connect( d->thread, SIGNAL(encryptionNegotiationResult(bool,KTcpSocket::SslVersion)),
+           d, SLOT(onEncryptionNegotiationResult(bool,KTcpSocket::SslVersion)) );
+  connect( d->thread, SIGNAL(sslError(KSslErrorUiData)),
+           d, SLOT(handleSslError(KSslErrorUiData)) );
+  connect( d->thread, SIGNAL(socketDisconnected()),
+           d, SLOT(socketDisconnected()) );
+  connect( d->thread, SIGNAL(responseReceived(KIMAP::Message)),
+           d, SLOT(responseReceived(KIMAP::Message)) );
+  connect( d->thread, SIGNAL(socketConnected()),
+           d, SLOT(socketConnected()) );
+  connect( d->thread, SIGNAL(socketActivity()),
+           d, SLOT(socketActivity()) );
+  connect( d->thread, SIGNAL(socketError()),
+           d, SLOT(socketError()) );
 
   d->startSocketTimer();
-  d->thread->start();
 }
 
 Session::~Session()
@@ -114,22 +125,19 @@ void KIMAP::Session::close()
 
 void SessionPrivate::handleSslError(const KSslErrorUiData& errorData)
 {
-  if (uiProxy && uiProxy->ignoreSslError(errorData)) {
-    QMetaObject::invokeMethod( thread, "sslErrorHandlerResponse", Q_ARG(bool, true) );
-  } else {
-    QMetaObject::invokeMethod( thread, "sslErrorHandlerResponse", Q_ARG(bool, false) );
-  }
+  const bool ignoreSslError = uiProxy && uiProxy->ignoreSslError( errorData );
+  thread->sslErrorHandlerResponse(ignoreSslError);
 }
 
 SessionPrivate::SessionPrivate( Session *session )
   : QObject( session ),
-    q(session),
-    state(Session::Disconnected),
-    logger(0),
-    currentJob(0),
-    tagCount(0),
-    sslVersion(KTcpSocket::UnknownSslVersion),
-    socketTimerInterval(30000) // By default timeouts on 30s
+    q( session ),
+    state( Session::Disconnected ),
+    logger( 0 ),
+    currentJob( 0 ),
+    tagCount( 0 ),
+    sslVersion( KTcpSocket::UnknownSslVersion ),
+    socketTimerInterval( 30000 ) // By default timeouts on 30s
 {
 }
 
@@ -140,20 +148,20 @@ SessionPrivate::~SessionPrivate()
 
 void SessionPrivate::addJob(Job *job)
 {
-  queue.append(job);
+  queue.append( job );
   emit q->jobQueueSizeChanged( q->jobQueueSize() );
 
-  QObject::connect( job, SIGNAL(result(KJob*)), q, SLOT(jobDone(KJob*)) );
-  QObject::connect( job, SIGNAL(destroyed(QObject*)), q, SLOT(jobDestroyed(QObject*)) );
+  QObject::connect( job, SIGNAL(result(KJob*)), this, SLOT(jobDone(KJob*)) );
+  QObject::connect( job, SIGNAL(destroyed(QObject*)), this, SLOT(jobDestroyed(QObject*)) );
 
-  if ( state!=Session::Disconnected ) {
+  if ( state != Session::Disconnected ) {
     startNext();
   }
 }
 
 void SessionPrivate::startNext()
 {
-  QTimer::singleShot( 0, q, SLOT(doStartNext()) );
+  QMetaObject::invokeMethod( this, "doStartNext" );
 }
 
 void SessionPrivate::doStartNext()
@@ -190,13 +198,14 @@ void SessionPrivate::jobDone( KJob *job )
 void SessionPrivate::jobDestroyed( QObject *job )
 {
   queue.removeAll( static_cast<KIMAP::Job*>( job ) );
-  if ( currentJob == job )
+  if ( currentJob == job ) {
     currentJob = 0;
+  }
 }
 
 void SessionPrivate::responseReceived( const Message &response )
 {
-  if ( logger && ( state==Session::Authenticated || state==Session::Selected ) ) {
+  if ( logger && ( state == Session::Authenticated || state == Session::Selected ) ) {
     logger->dataReceived( response.toString() );
   }
 
@@ -213,11 +222,11 @@ void SessionPrivate::responseReceived( const Message &response )
 
   switch ( state ) {
   case Session::Disconnected:
-    if (socketTimer.isActive()) {
+    if ( socketTimer.isActive() ) {
       stopSocketTimer();
     }
-    if ( code=="OK" ) {
-      setState(Session::NotAuthenticated);
+    if ( code == "OK" ) {
+      setState( Session::NotAuthenticated );
 
       Message simplified = response;
       simplified.content.removeFirst(); // Strip the tag
@@ -225,8 +234,8 @@ void SessionPrivate::responseReceived( const Message &response )
       greeting = simplified.toString().trimmed(); // Save the server greeting
 
       startNext();
-    } else if ( code=="PREAUTH" ) {
-      setState(Session::Authenticated);
+    } else if ( code == "PREAUTH" ) {
+      setState( Session::Authenticated );
 
       Message simplified = response;
       simplified.content.removeFirst(); // Strip the tag
@@ -239,74 +248,79 @@ void SessionPrivate::responseReceived( const Message &response )
     }
     return;
   case Session::NotAuthenticated:
-    if ( code=="OK" && tag==authTag ) {
-      setState(Session::Authenticated);
+    if ( code == "OK" && tag == authTag ) {
+      setState( Session::Authenticated );
     }
     break;
   case Session::Authenticated:
-    if ( code=="OK" && tag==selectTag ) {
-      setState(Session::Selected);
+    if ( code == "OK" && tag == selectTag ) {
+      setState( Session::Selected );
       currentMailBox = upcomingMailBox;
     }
     break;
   case Session::Selected:
-    if ( ( code=="OK" && tag==closeTag )
-      || ( code!="OK" && tag==selectTag) ) {
-      setState(Session::Authenticated);
+    if ( ( code == "OK" && tag == closeTag ) ||
+         ( code != "OK" && tag == selectTag ) ) {
+      setState( Session::Authenticated );
       currentMailBox = QByteArray();
-    } else if ( code=="OK" && tag==selectTag ) {
+    } else if ( code == "OK" && tag == selectTag ) {
       currentMailBox = upcomingMailBox;
     }
     break;
   }
 
-  if (tag==authTag) authTag.clear();
-  if (tag==selectTag) selectTag.clear();
-  if (tag==closeTag) closeTag.clear();
+  if ( tag == authTag ) {
+    authTag.clear();
+  }
+  if ( tag == selectTag ) {
+    selectTag.clear();
+  }
+  if ( tag == closeTag ) {
+    closeTag.clear();
+  }
 
   // If a job is running forward it the response
-  if ( currentJob!=0 ) {
+  if ( currentJob != 0 ) {
     restartSocketTimer();
     currentJob->handleResponse( response );
   } else {
     qWarning() << "A message was received from the server with no job to handle it:"
                << response.toString()
-               << '('+response.toString().toHex()+')';
+               << '(' + response.toString().toHex() + ')';
   }
 }
 
 void SessionPrivate::setState(Session::State s)
 {
-  if (s != state) {
+  if ( s != state ) {
     Session::State oldState = state;
     state = s;
-    emit q->stateChanged(state, oldState);
+    emit q->stateChanged( state, oldState );
   }
 }
 
 QByteArray SessionPrivate::sendCommand( const QByteArray &command, const QByteArray &args )
 {
-  QByteArray tag = 'A' + QByteArray::number(++tagCount).rightJustified(6, '0');
+  QByteArray tag = 'A' + QByteArray::number( ++tagCount ).rightJustified( 6, '0' );
 
-  QByteArray payload = tag+' '+command;
+  QByteArray payload = tag + ' ' + command;
   if ( !args.isEmpty() ) {
-    payload+= ' '+args;
+    payload += ' ' + args;
   }
 
   sendData( payload );
 
-  if ( command=="LOGIN" || command=="AUTHENTICATE" ) {
+  if ( command == "LOGIN" || command == "AUTHENTICATE" ) {
     authTag = tag;
-  } else if ( command=="SELECT" || command=="EXAMINE" ) {
+  } else if ( command == "SELECT" || command == "EXAMINE" ) {
     selectTag = tag;
     upcomingMailBox = args;
     upcomingMailBox.remove( 0, 1 );
     upcomingMailBox.chop( 1 );
     upcomingMailBox = KIMAP::decodeImapFolderName( upcomingMailBox );
-  } else if ( command=="CLOSE" ) {
+  } else if ( command == "CLOSE" ) {
     closeTag = tag;
   }
-
   return tag;
 }
 
@@ -314,11 +328,11 @@ void SessionPrivate::sendData( const QByteArray &data )
 {
   restartSocketTimer();
 
-  if ( logger && ( state==Session::Authenticated || state==Session::Selected ) ) {
+  if ( logger && ( state == Session::Authenticated || state == Session::Selected ) ) {
     logger->dataSent( data );
   }
 
-  thread->sendData(data+"\r\n");
+  thread->sendData( data + "\r\n" );
 }
 
 void SessionPrivate::socketConnected()
@@ -330,10 +344,10 @@ void SessionPrivate::socketConnected()
   if ( !queue.isEmpty() ) {
     KIMAP::LoginJob *login = qobject_cast<KIMAP::LoginJob*>( queue.first() );
     if ( login ) {
-      willUseSsl = ( login->encryptionMode() == KIMAP::LoginJob::SslV2 )
-                || ( login->encryptionMode() == KIMAP::LoginJob::SslV3 )
-                || ( login->encryptionMode() == KIMAP::LoginJob::SslV3_1 )
-                || ( login->encryptionMode() == KIMAP::LoginJob::AnySslVersion );
+      willUseSsl = ( login->encryptionMode() == KIMAP::LoginJob::SslV2 ) ||
+                   ( login->encryptionMode() == KIMAP::LoginJob::SslV3 ) ||
+                   ( login->encryptionMode() == KIMAP::LoginJob::SslV3_1 ) ||
+                   ( login->encryptionMode() == KIMAP::LoginJob::AnySslVersion );
 
       userName = login->userName();
     }
@@ -348,16 +362,16 @@ void SessionPrivate::socketConnected()
 
 void SessionPrivate::socketDisconnected()
 {
-  if (socketTimer.isActive()) {
+  if ( socketTimer.isActive() ) {
     stopSocketTimer();
   }
 
-  if ( logger && ( state==Session::Authenticated || state==Session::Selected ) ) {
+  if ( logger && ( state == Session::Authenticated || state == Session::Selected ) ) {
     logger->disconnectionOccured();
   }
 
   if ( state != Session::Disconnected ) {
-    setState(Session::Disconnected);
+    setState( Session::Disconnected );
     emit q->connectionLost();
   } else {
     emit q->connectionFailed();
@@ -375,7 +389,7 @@ void SessionPrivate::socketActivity()
 
 void SessionPrivate::socketError()
 {
-  if (socketTimer.isActive()) {
+  if ( socketTimer.isActive() ) {
     stopSocketTimer();
   }
 
@@ -397,14 +411,15 @@ void SessionPrivate::clearJobQueue()
     currentJob->connectionLost();
   }
 
-  qDeleteAll(queue);
+  QQueue<Job*> queueCopy = queue; // copy because jobDestroyed calls removeAll
+  qDeleteAll(queueCopy);
   queue.clear();
   emit q->jobQueueSizeChanged( 0 );
 }
 
 void SessionPrivate::startSsl(const KTcpSocket::SslVersion &version)
 {
-  QMetaObject::invokeMethod( thread, "startSsl", Qt::QueuedConnection, Q_ARG(KTcpSocket::SslVersion, version) );
+  thread->startSsl( version );
 }
 
 QString Session::selectedMailBox() const
@@ -449,7 +464,7 @@ int SessionPrivate::socketTimeout() const
 
 void SessionPrivate::startSocketTimer()
 {
-  if ( socketTimerInterval<0 ) {
+  if ( socketTimerInterval < 0 ) {
     return;
   }
   Q_ASSERT( !socketTimer.isActive() );
@@ -463,7 +478,7 @@ void SessionPrivate::startSocketTimer()
 
 void SessionPrivate::stopSocketTimer()
 {
-  if ( socketTimerInterval<0 ) {
+  if ( socketTimerInterval < 0 ) {
     return;
   }
 
@@ -483,7 +498,7 @@ void SessionPrivate::restartSocketTimer()
 
 void SessionPrivate::onSocketTimeout()
 {
-  qDebug() << "Socket timeout!";
+  kDebug() << "Socket timeout!";
   thread->closeSocket();
 }
 
@@ -494,3 +509,4 @@ void Session::setTimeout( int timeout )
 
 #include "session.moc"
 #include "session_p.moc"
+
diff --git a/kimap/session.h b/kimap/session.h
index e23fbc4..b745246 100644
--- a/kimap/session.h
+++ b/kimap/session.h
@@ -37,7 +37,7 @@ struct Message;
 class KIMAP_EXPORT Session : public QObject
 {
   Q_OBJECT
-  Q_ENUMS(State)
+  Q_ENUMS( State )
 
   friend class JobPrivate;
 
@@ -135,18 +135,6 @@ class KIMAP_EXPORT Session : public QObject
     void stateChanged(KIMAP::Session::State newState, KIMAP::Session::State oldState);
 
   private:
-    Q_PRIVATE_SLOT( d, void doStartNext() )
-    Q_PRIVATE_SLOT( d, void jobDone( KJob* ) )
-    Q_PRIVATE_SLOT( d, void jobDestroyed( QObject* ) )
-    Q_PRIVATE_SLOT( d, void responseReceived( const KIMAP::Message& ) )
-
-    Q_PRIVATE_SLOT( d, void socketConnected() )
-    Q_PRIVATE_SLOT( d, void socketDisconnected() )
-    Q_PRIVATE_SLOT( d, void socketError() )
-    Q_PRIVATE_SLOT( d, void socketActivity() )
-
-    Q_PRIVATE_SLOT( d, void handleSslError( const KSslErrorUiData &errorData ) )
-
     friend class SessionPrivate;
     SessionPrivate *const d;
 };
diff --git a/kimap/session_p.h b/kimap/session_p.h
index 37bfd57..fd5101b 100644
--- a/kimap/session_p.h
+++ b/kimap/session_p.h
@@ -46,7 +46,7 @@ class KIMAP_EXPORT SessionPrivate : public QObject
   friend class Session;
 
   public:
-    SessionPrivate( Session *session );
+    explicit SessionPrivate( Session *session );
     virtual ~SessionPrivate();
 
     void addJob(Job *job);
@@ -54,8 +54,6 @@ class KIMAP_EXPORT SessionPrivate : public QObject
     void startSsl(const KTcpSocket::SslVersion &version);
     void sendData( const QByteArray &data );
 
-    void handleSslError( const KSslErrorUiData &errorData );
-
     KTcpSocket::SslVersion negotiatedEncryption() const;
 
     void setSocketTimeout( int ms );
@@ -68,20 +66,23 @@ class KIMAP_EXPORT SessionPrivate : public QObject
     void onEncryptionNegotiationResult(bool isEncrypted, KTcpSocket::SslVersion sslVersion);
     void onSocketTimeout();
 
-  private:
-    void startNext();
     void doStartNext();
-    void jobDone( KJob *job );
-    void jobDestroyed( QObject *job );
-    void clearJobQueue();
-    void responseReceived( const KIMAP::Message &response );
-    void setState(Session::State state);
+    void jobDone( KJob* );
+    void jobDestroyed( QObject* );
+    void responseReceived( const KIMAP::Message& );
 
     void socketConnected();
     void socketDisconnected();
     void socketError();
     void socketActivity();
 
+    void handleSslError( const KSslErrorUiData &errorData );
+
+  private:
+    void startNext();
+    void clearJobQueue();
+    void setState(Session::State state);
+
     void startSocketTimer();
     void stopSocketTimer();
     void restartSocketTimer();
diff --git a/kimap/sessionlogger.cpp b/kimap/sessionlogger.cpp
index 715a5da..2c4bd07 100644
--- a/kimap/sessionlogger.cpp
+++ b/kimap/sessionlogger.cpp
@@ -20,6 +20,8 @@
 
 #include "sessionlogger_p.h"
 
+#include <KDebug>
+
 #include <unistd.h>
 
 using namespace KIMAP;
@@ -33,7 +35,9 @@ SessionLogger::SessionLogger()
   m_file.setFileName( qgetenv( "KIMAP_LOGFILE" )
                     + '.' + QString::number( getpid() )
                     + '.' + QString::number( m_id ) );
-  m_file.open( QFile::WriteOnly );
+  if (!m_file.open( QFile::WriteOnly )) {
+     kDebug()<<" m_file can be open in write only";
+  }
 }
 
 SessionLogger::~SessionLogger()
@@ -57,6 +61,3 @@ void SessionLogger::disconnectionOccured()
 {
   m_file.write( "X\n" );
 }
-
-
-
diff --git a/kimap/sessionthread.cpp b/kimap/sessionthread.cpp
index b7a1cb9..36e2c83 100644
--- a/kimap/sessionthread.cpp
+++ b/kimap/sessionthread.cpp
@@ -20,65 +20,73 @@
 #include "sessionthread_p.h"
 
 #include <QtCore/QDebug>
-#include <QtCore/QTimer>
+#include <QtCore/QThread>
 
-#include <kdebug.h>
+#include <KDE/KDebug>
 
 #include "imapstreamparser.h"
 #include "message_p.h"
-#include "session.h"
 
 using namespace KIMAP;
 
-Q_DECLARE_METATYPE(KTcpSocket::Error)
-Q_DECLARE_METATYPE(KSslErrorUiData)
+Q_DECLARE_METATYPE( KTcpSocket::Error )
+Q_DECLARE_METATYPE( KSslErrorUiData )
 static const int _kimap_socketErrorTypeId = qRegisterMetaType<KTcpSocket::Error>();
 static const int _kimap_sslErrorUiData = qRegisterMetaType<KSslErrorUiData>();
 
-SessionThread::SessionThread( const QString &hostName, quint16 port, Session *parent )
-  : QThread(), m_hostName(hostName), m_port(port),
-    m_session(parent), m_socket(0), m_stream(0), m_encryptedMode(false)
+SessionThread::SessionThread( const QString &hostName, quint16 port )
+  : QObject(), m_hostName( hostName ), m_port( port ),
+    m_socket( 0 ), m_stream( 0 ), m_mutex(),
+    m_encryptedMode( false ),
+    triedSslVersions( 0 ), doSslFallback( false )
 {
-  // Yeah, sounds weird, but QThread object is linked to the parent
-  // thread not to itself, and I'm too lazy to introduce yet another
-  // internal QObject
-  moveToThread(this);
+  // Just like the Qt docs now recommend, for event-driven threads:
+  // don't derive from QThread, create one directly and move the object to it.
+  QThread* thread = new QThread();
+  moveToThread( thread );
+  thread->start();
+  QMetaObject::invokeMethod( this, "threadInit" );
 }
 
 SessionThread::~SessionThread()
 {
-  // don't call quit() directly, this will deadlock in wait() if exec() hasn't run yet
-  QMetaObject::invokeMethod( this, "quit" );
-  if ( !wait( 10 * 1000 ) ) {
+  QMetaObject::invokeMethod( this, "threadQuit" );
+  if ( !thread()->wait( 10 * 1000 ) ) {
     kWarning() << "Session thread refuses to die, killing harder...";
-    terminate();
+    thread()->terminate();
     // Make sure to wait until it's done, otherwise it can crash when the pthread callback is called
-    wait();
+    thread()->wait();
   }
+  delete thread();
 }
 
+// Called in primary thread
 void SessionThread::sendData( const QByteArray &payload )
 {
-  QMutexLocker locker(&m_mutex);
+  QMutexLocker locker( &m_mutex );
 
   m_dataQueue.enqueue( payload );
-  QTimer::singleShot( 0, this, SLOT(writeDataQueue()) );
+  QMetaObject::invokeMethod( this, "writeDataQueue" );
 }
 
+// Called in secondary thread
 void SessionThread::writeDataQueue()
 {
-  QMutexLocker locker(&m_mutex);
+  Q_ASSERT( QThread::currentThread() == thread() );
+  if ( !m_socket )
+    return;
+  QMutexLocker locker( &m_mutex );
 
   while ( !m_dataQueue.isEmpty() ) {
     m_socket->write( m_dataQueue.dequeue() );
   }
 }
 
+// Called in secondary thread
 void SessionThread::readMessage()
 {
-  QMutexLocker locker(&m_mutex);
-
-  if ( m_stream->availableDataSize()==0 ) {
+  Q_ASSERT( QThread::currentThread() == thread() );
+  if ( !m_stream || m_stream->availableDataSize() == 0 ) {
     return;
   }
 
@@ -92,10 +100,10 @@ void SessionThread::readMessage()
         if ( string == "NIL" ) {
           *payload << Message::Part( QList<QByteArray>() );
         } else {
-          *payload << Message::Part(string);
+          *payload << Message::Part( string );
         }
       } else if ( m_stream->hasList() ) {
-        *payload << Message::Part(m_stream->readParenthesizedList());
+        *payload << Message::Part( m_stream->readParenthesizedList() );
       } else if ( m_stream->hasResponseCode() ) {
         payload = &message.responseCode;
       } else if ( m_stream->atResponseCodeEnd() ) {
@@ -103,128 +111,213 @@ void SessionThread::readMessage()
       } else if ( m_stream->hasLiteral() ) {
         QByteArray literal;
         while ( !m_stream->atLiteralEnd() ) {
-          literal+= m_stream->readLiteralPart();
+          literal += m_stream->readLiteralPart();
         }
-        *payload << Message::Part(literal);
+        *payload << Message::Part( literal );
       } else {
-        // Oops! Something really bad happened
-        throw ImapParserException( "Inconsistent state, probably due to some packet loss" );
+        // Oops! Something really bad happened, we won't be able to recover
+        // so close the socket immediately
+        qWarning( "Inconsistent state, probably due to some packet loss" );
+        doCloseSocket();
+        return;
       }
     }
 
-    emit responseReceived(message);
+    emit responseReceived( message );
 
-  } catch (KIMAP::ImapParserException e) {
+  } catch ( KIMAP::ImapParserException e ) {
     qWarning() << "The stream parser raised an exception:" << e.what();
   }
 
-  if ( m_stream->availableDataSize()>1 ) {
-    QTimer::singleShot( 0, this, SLOT(readMessage()) );
+  if ( m_stream->availableDataSize() > 1 ) {
+    QMetaObject::invokeMethod( this, "readMessage", Qt::QueuedConnection );
   }
 
 }
 
+// Called in main thread
 void SessionThread::closeSocket()
 {
-  QTimer::singleShot( 0, this, SLOT(doCloseSocket()) );
+  QMetaObject::invokeMethod( this, "doCloseSocket", Qt::QueuedConnection );
 }
 
+// Called in secondary thread
 void SessionThread::doCloseSocket()
 {
+  Q_ASSERT( QThread::currentThread() == thread() );
+  if ( !m_socket )
+    return;
   m_encryptedMode = false;
+  kDebug() << "close";
   m_socket->close();
 }
 
+// Called in secondary thread
 void SessionThread::reconnect()
 {
-  QMutexLocker locker(&m_mutex);
-
+  Q_ASSERT( QThread::currentThread() == thread() );
+  if ( m_socket == 0 ) // threadQuit already called
+    return;
   if ( m_socket->state() != SessionSocket::ConnectedState &&
        m_socket->state() != SessionSocket::ConnectingState ) {
-    if (m_encryptedMode) {
-      m_socket->connectToHostEncrypted(m_hostName, m_port);
+    if ( m_encryptedMode ) {
+      kDebug() << "connectToHostEncrypted" << m_hostName << m_port;
+      m_socket->connectToHostEncrypted( m_hostName, m_port );
     } else {
-      m_socket->connectToHost(m_hostName, m_port);
+      kDebug() << "connectToHost" << m_hostName << m_port;
+      m_socket->connectToHost( m_hostName, m_port );
     }
   }
 }
 
-void SessionThread::run()
+// Called in secondary thread
+void SessionThread::threadInit()
 {
+  Q_ASSERT( QThread::currentThread() == thread() );
   m_socket = new SessionSocket;
   m_stream = new ImapStreamParser( m_socket );
   connect( m_socket, SIGNAL(readyRead()),
            this, SLOT(readMessage()), Qt::QueuedConnection );
 
+  // Delay the call to slotSocketDisconnected so that it finishes disconnecting before we call reconnect()
   connect( m_socket, SIGNAL(disconnected()),
-           m_session, SLOT(socketDisconnected()) );
+           this, SLOT(slotSocketDisconnected()), Qt::QueuedConnection );
   connect( m_socket, SIGNAL(connected()),
-           m_session, SLOT(socketConnected()) );
+           this, SIGNAL(socketConnected()) );
   connect( m_socket, SIGNAL(error(KTcpSocket::Error)),
-           m_session, SLOT(socketError()) );
+           this, SLOT(socketError(KTcpSocket::Error)) );
   connect( m_socket, SIGNAL(bytesWritten(qint64)),
-           m_session, SLOT(socketActivity()) );
-  if ( m_socket->metaObject()->indexOfSignal("encryptedBytesWritten(qint64)" ) > -1 ) {
+           this, SIGNAL(socketActivity()) );
+  if ( m_socket->metaObject()->indexOfSignal( "encryptedBytesWritten(qint64)" ) > -1 ) {
       connect( m_socket, SIGNAL(encryptedBytesWritten(qint64)), // needs kdelibs > 4.8
-               m_session, SLOT(socketActivity()) );
+               this, SIGNAL(socketActivity()) );
   }
   connect( m_socket, SIGNAL(readyRead()),
-           m_session, SLOT(socketActivity()) );
-
-  connect( this, SIGNAL(responseReceived(KIMAP::Message)),
-           m_session, SLOT(responseReceived(KIMAP::Message)) );
+           this, SIGNAL(socketActivity()) );
 
-  QTimer::singleShot( 0, this, SLOT(reconnect()) );
-  exec();
+  QMetaObject::invokeMethod(this, "reconnect", Qt::QueuedConnection);
+}
 
+// Called in secondary thread
+void SessionThread::threadQuit()
+{
+  Q_ASSERT( QThread::currentThread() == thread() );
   delete m_stream;
+  m_stream = 0;
   delete m_socket;
+  m_socket = 0;
+  thread()->quit();
 }
 
-void SessionThread::startSsl(const KTcpSocket::SslVersion &version)
+// Called in primary thread
+void SessionThread::startSsl( KTcpSocket::SslVersion version )
 {
-  QMutexLocker locker(&m_mutex);
+  QMetaObject::invokeMethod( this, "doStartSsl", Q_ARG(KTcpSocket::SslVersion, version) );
+}
+
+// Called in secondary thread (via invokeMethod)
+void SessionThread::doStartSsl( KTcpSocket::SslVersion version )
+{
+  Q_ASSERT( QThread::currentThread() == thread() );
+  if ( !m_socket )
+    return;
+  if ( version == KTcpSocket::AnySslVersion ) {
+    doSslFallback = true;
+    if ( m_socket->advertisedSslVersion() == KTcpSocket::UnknownSslVersion ) {
+      m_socket->setAdvertisedSslVersion( KTcpSocket::AnySslVersion );
+    } else if ( !( triedSslVersions & KTcpSocket::TlsV1 ) ) {
+      triedSslVersions |= KTcpSocket::TlsV1;
+      m_socket->setAdvertisedSslVersion( KTcpSocket::TlsV1 );
+    } else if ( !( triedSslVersions & KTcpSocket::SslV3 ) ) {
+      triedSslVersions |= KTcpSocket::SslV3;
+      m_socket->setAdvertisedSslVersion( KTcpSocket::SslV3 );
+    } else if ( !( triedSslVersions & KTcpSocket::SslV2 ) ) {
+      triedSslVersions |= KTcpSocket::SslV2;
+      m_socket->setAdvertisedSslVersion( KTcpSocket::SslV2 );
+      doSslFallback = false;
+    }
+  } else {
+    m_socket->setAdvertisedSslVersion( version );
+  }
 
-  m_socket->setAdvertisedSslVersion(version);
   m_socket->ignoreSslErrors();
-  connect(m_socket, SIGNAL(encrypted()), this, SLOT(sslConnected()));
+  connect( m_socket, SIGNAL(encrypted()), this, SLOT(sslConnected()) );
   m_socket->startClientEncryption();
 }
 
+// Called in secondary thread
+void SessionThread::slotSocketDisconnected()
+{
+  Q_ASSERT( QThread::currentThread() == thread() );
+  if ( doSslFallback ) {
+    reconnect();
+  } else {
+    emit socketDisconnected();
+  }
+}
+
+// Called in secondary thread
+void SessionThread::socketError(KTcpSocket::Error error)
+{
+  Q_ASSERT( QThread::currentThread() == thread() );
+  if ( !m_socket )
+    return;
+  Q_UNUSED( error ); // can be used for debugging
+  if ( doSslFallback ) {
+    //do not call m_socket->disconnectFromHost() here, as that can trigger an error again (resulting in an endless loop).
+    m_socket->abort();
+  } else {
+    emit socketError();
+  }
+}
+
+// Called in secondary thread
 void SessionThread::sslConnected()
 {
-  QMutexLocker locker(&m_mutex);
+  Q_ASSERT( QThread::currentThread() == thread() );
+  if ( !m_socket )
+    return;
   KSslCipher cipher = m_socket->sessionCipher();
 
-  if ( m_socket->sslErrors().count() > 0 || m_socket->encryptionMode() != KTcpSocket::SslClientMode
-      || cipher.isNull() || cipher.usedBits() == 0) {
-      qDebug() << "Initial SSL handshake failed. cipher.isNull() is" << cipher.isNull()
-                    << ", cipher.usedBits() is" << cipher.usedBits()
-                    << ", the socket says:" <<  m_socket->errorString()
-                    << "and the list of SSL errors contains"
-                    << m_socket->sslErrors().count() << "items.";
-     KSslErrorUiData errorData(m_socket);
-     emit sslError(errorData);
+  if ( m_socket->sslErrors().count() > 0 ||
+       m_socket->encryptionMode() != KTcpSocket::SslClientMode ||
+       cipher.isNull() || cipher.usedBits() == 0 ) {
+     kDebug() << "Initial SSL handshake failed. cipher.isNull() is" << cipher.isNull()
+              << ", cipher.usedBits() is" << cipher.usedBits()
+              << ", the socket says:" <<  m_socket->errorString()
+              << "and the list of SSL errors contains"
+              << m_socket->sslErrors().count() << "items.";
+     KSslErrorUiData errorData( m_socket );
+     emit sslError( errorData );
   } else {
-    qDebug() << "TLS negotiation done.";
+    doSslFallback = false;
+    kDebug() << "TLS negotiation done.";
     m_encryptedMode = true;
-    emit encryptionNegotiationResult(true, m_socket->negotiatedSslVersion());
+    emit encryptionNegotiationResult( true, m_socket->negotiatedSslVersion() );
   }
 }
 
 void SessionThread::sslErrorHandlerResponse(bool response)
 {
-  QMutexLocker locker(&m_mutex);
-  if (response) {
+  QMetaObject::invokeMethod(this, "doSslErrorHandlerResponse", Q_ARG(bool, response));
+}
+
+// Called in secondary thread (via invokeMethod)
+void SessionThread::doSslErrorHandlerResponse(bool response)
+{
+  Q_ASSERT( QThread::currentThread() == thread() );
+  if ( !m_socket )
+    return;
+  if ( response ) {
     m_encryptedMode = true;
-    emit encryptionNegotiationResult(true, m_socket->negotiatedSslVersion());
+    emit encryptionNegotiationResult( true, m_socket->negotiatedSslVersion() );
   } else {
      m_encryptedMode = false;
      //reconnect in unencrypted mode, so new commands can be issued
      m_socket->disconnectFromHost();
      m_socket->waitForDisconnected();
-     m_socket->connectToHost(m_hostName, m_port);
-     emit encryptionNegotiationResult(false, KTcpSocket::UnknownSslVersion);
+     m_socket->connectToHost( m_hostName, m_port );
+     emit encryptionNegotiationResult( false, KTcpSocket::UnknownSslVersion );
   }
 }
 
diff --git a/kimap/sessionthread_p.h b/kimap/sessionthread_p.h
index 672c418..47a94fb 100644
--- a/kimap/sessionthread_p.h
+++ b/kimap/sessionthread_p.h
@@ -22,7 +22,6 @@
 
 #include <QtCore/QMutex>
 #include <QtCore/QQueue>
-#include <QtCore/QThread>
 
 #include <ktcpsocket.h>
 
@@ -32,52 +31,62 @@ namespace KIMAP {
 
 class ImapStreamParser;
 struct Message;
-class Session;
 
-class SessionThread : public QThread
+class SessionThread : public QObject
 {
   Q_OBJECT
 
   public:
-    explicit SessionThread( const QString &hostName, quint16 port, Session *parent );
+    explicit SessionThread( const QString &hostName, quint16 port );
     ~SessionThread();
 
     inline QString hostName() { return m_hostName; }
     inline quint16 port() { return m_port; }
 
     void sendData( const QByteArray &payload );
-    void run();
 
   public slots:
     void closeSocket();
-    void reconnect();
-    void startSsl(const KTcpSocket::SslVersion &version);
+    void startSsl(KTcpSocket::SslVersion version);
+    void sslErrorHandlerResponse(bool result);
 
   signals:
+    void socketConnected();
+    void socketDisconnected();
+    void socketActivity();
+    void socketError();
     void responseReceived(const KIMAP::Message &response);
     void encryptionNegotiationResult(bool, KTcpSocket::SslVersion);
     void sslError(const KSslErrorUiData&);
 
   private slots:
+    void reconnect();
+    void threadInit();
+    void threadQuit();
     void readMessage();
     void writeDataQueue();
     void sslConnected();
-    void sslErrorHandlerResponse(bool result);
     void doCloseSocket();
+    void socketError(KTcpSocket::Error);
+    void slotSocketDisconnected();
+    void doStartSsl(KTcpSocket::SslVersion);
+    void doSslErrorHandlerResponse(bool result);
 
   private:
     QString m_hostName;
     quint16 m_port;
 
-    Session *m_session;
     SessionSocket *m_socket;
     ImapStreamParser *m_stream;
 
     QQueue<QByteArray> m_dataQueue;
 
+    // Protects m_dataQueue
     QMutex m_mutex;
 
     bool m_encryptedMode;
+    KTcpSocket::SslVersions triedSslVersions;
+    bool doSslFallback;
 };
 
 }
